# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ..core.pydantic_utilities import UniversalBaseModel
from .api_request_parent_context import ApiRequestParentContext
from .node_parent_context import NodeParentContext
from .prompt_deployment_parent_context import PromptDeploymentParentContext
from .span_link import SpanLink
from .workflow_deployment_parent_context import WorkflowDeploymentParentContext
from .workflow_parent_context import WorkflowParentContext
from .workflow_sandbox_parent_context import WorkflowSandboxParentContext
import typing
from .vellum_node_execution_event import VellumNodeExecutionEvent
from .node_execution_span_attributes import NodeExecutionSpanAttributes
import datetime as dt
from ..core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic
from ..core.pydantic_utilities import update_forward_refs


class NodeExecutionSpan(UniversalBaseModel):
    name: typing.Literal["node.execution"] = "node.execution"
    events: typing.List[VellumNodeExecutionEvent]
    attributes: NodeExecutionSpanAttributes
    span_id: str
    start_ts: dt.datetime
    end_ts: dt.datetime
    parent_span_id: typing.Optional[str] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


update_forward_refs(ApiRequestParentContext, NodeExecutionSpan=NodeExecutionSpan)
update_forward_refs(NodeParentContext, NodeExecutionSpan=NodeExecutionSpan)
update_forward_refs(PromptDeploymentParentContext, NodeExecutionSpan=NodeExecutionSpan)
update_forward_refs(SpanLink, NodeExecutionSpan=NodeExecutionSpan)
update_forward_refs(WorkflowDeploymentParentContext, NodeExecutionSpan=NodeExecutionSpan)
update_forward_refs(WorkflowParentContext, NodeExecutionSpan=NodeExecutionSpan)
update_forward_refs(WorkflowSandboxParentContext, NodeExecutionSpan=NodeExecutionSpan)
